	page	,132
	title	Encode XPL programs using only ASCII
HOOKS = 1	;set to 1 to put in debugging "hooks"
;
MINBUF = 2
;
USEI3HOOK = 0
;
hookcode macro
IF USEI3HOOK
	int	3
ELSE
	nop
endIF
	ret
	endm
;
doparm1 macro
	endm
;
doparm2 macro
	call	optnchk 	;check for options
	endm
;
doparm3 macro
;
opttest proc	near
	xor	cl,al		;XOR char into test char
	and	cl,255-20h	;test all but case-varying bit
	jnz	optret		;jmp if no match
	mov	ah,ch		;set flags if match
optret: ret
opttest endp
;
dectest proc	near
	cmp	al,'9'+1
	cmc
	jb	dect02		;ret w/carry if > '9'
	cmp	al,'0'		;set carry if < '0'
dect02: ret
dectest endp
;
settbl	proc	near
	mov	di,si
sett02: lodsb
	cmp	al,1	;set for pass through?
	jne	sett04	;let current setting ride if not
	mov	al,ah	;set for ~x or ~ddd encoding
sett04: stosb
	loop	sett02
	ret
settbl	endp
;
optnchk proc	near
IF HOOKS
	call	optdebug
endIF
	xor	bx,bx		;clear options result
optn02: lodsw			;get two bytes
	dec	si		;but space over only one
	xchg	ah,al		;test if ...
	call	dectest 	;... AH is ...
	xchg	ah,al		;... '0' to '9'
	jc	optn06		;jmp if not
	call	dectest 	;test if AL is '0' to '9'
	jc	optn06		;jmp if not
;two digits found
	test	bl,bl
	jnz	optn08		;don't recognize if 2nd time
	sub	ax,'0'*101h	;map '0' to 0, both digits
	mov	bl,ah		;low digit
	mov	cl,10
	mul	cl		;AL=high digit times 10, AH=0
	add	bl,al		;add in high digit*10
	cmp	bl,20		;arg must be at least 20
	jb	optn08		;don't recognize if below 20
	inc	si		;accept 2nd byte
optn04: call	blnkskp 	;skip blanks and tabs
	jmp	short optn02	;look for more
;not 2 digits. L/H/B/C are the other thing we recognize
optn06: mov	ah,0
	mov	cx,100h+'L'
	call	opttest
	mov	cx,200h+'H'
	call	opttest
	mov	cx,300h+'B'	;same as 'L' AND 'H'
	call	opttest
	mov	cx,400h+'C'
	call	opttest
	test	ah,ah
	jz	optn08		;not one of those
	or	bh,ah
	jmp	short optn04
;
optn08: dec	si		;back up over unrecognized
	push	si
	push	di
	push	dx
	mov	cx,32
	test	bh,1		;'L' switch?
	jnz	optn10		;tbl is inited for 'L', so jump
	mov	si,offset ctbl
	mov	ah,3		;change passthrus to TILDE2
	call	settbl		;set translate all Ctrl chars
optn10: mov	cl,128-3
	test	bh,2		;'H' switch?
	jnz	optn12		;tbl is inited for 'H', so jump
	mov	si,offset htbl
	mov	ah,5		;change passthrus to ABOVE127
	call	settbl		;set to translate all above 80h
optn12: test	bl,bl		;line length specified?
	jz	optn14		;jmp if not
	sub	bl,4
	mov	byte ptr ds:maxline,bl
optn14: test	bh,4		;'C' specified
	jz	optn16		;jmp if not
	inc	byte ptr ds:crc32sw ;indicate doing CRC
;'crcbld' routine included here in-line
;build the tables we need to generate a CRC32 checksum
	xor	bx,bx
tc02:	xor	dx,dx		;accumlator high
	mov	di,bx		;accumlator low
	mov	cl,8		;count
	lea	si,ds:[bx+di]	;offset into table(s)
tc04:	shr	dx,1		;shift accum hi right 1, low bit into carry
	rcr	di,1		;shift accum lo right 1, carry into high
				;bit, and low bit into carry
	jnc	tc06		;jmp if low bit was zero
	xor	dx,0EDB8h
	xor	di,08320h
;
;Source of above the above DX:DI constant
;
;The polynomial for CRC 32 is
;  32  26  23  22  16  12  11  10  8  7  5  4  2  1  0	(<== exponents)
; x  +x  +x  +x  +x  +x  +x  +x  +x +x +x +x +x +x +x
;
;The above constant (XOR'ed to DX:DI) is 0EDB88320h. In binary, this is
;1 1 1 0 1 1 0 1 1 0 1  1  1 0 0 0 1 0 0 0 0 0 1  1 0 0 1 0 0 0 0 0  (binary)
;0   2   4   6   8   10    12  14  16  18  20  22   24  26  28  30   (bit ..
;  1   3   5   7   9    11   13  15  17  19  21   23  25  27  29  31 ..numbers)
;0 1 2   4 5   7 8   10 11 12      16          22 23    26 <= (selected bit
;	bit numbers (the x-to-the-32nd term is implicit))
;The selected bits match the exponents of the polynomial, representing
;feedback (XOR) for the corresponding bits.
;
tc06:	loop	tc04
	mov	word ptr ds:crctab[si],di
	mov	word ptr ds:crctabh[si],dx
	inc	bx
	test	bh,bh
	jz	tc02
optn16: pop	dx
	pop	di
	pop	si
	xor	ax,ax
	ret
optnchk endp
	endm
;
dovars	macro
	endm
;
doread	macro
	call	crc32in
	endm
;
dowrite macro
	mov	byte ptr cs:didwrite,1
	endm
;
include inout.inc
;
t = (offset s0+8000h-$) mod 16
IF t
	db	t dup(0)
endIF
;
FECODE	equ	7	;0FEh prefixed 3 byte encoded entity
FFCODE	equ	6	;0FFh prefixed 3 byte encoded entity
ABOVE127 equ	5	;other chars above 80h
QUOTE2	equ	4	;chars with rsquote prefixed represention
TILDE2	equ	3	;chars with tilde prefixed representation
BLANK	equ	2	;for blank - translate to '_'
NORMAL	equ	1	;normal chars that are just passed through
;		0 1 2 3 4 5 6 7 8 9 A B C D E F
IF 1
;these two rows of the table correspond to operation with the 'L'
;parameter specified. If the 'L' parameter is NOT specified, these two
;rows are overriden to match what's in the ELSE case below
ctbl	db	3,1,1,1,1,1,1,1,3,3,3,1,1,3,1,1 ;00 000 ~@ - ~O
	db	1,3,1,1,1,1,1,1,1,1,3,3,1,1,1,1 ;10 016 ~P - ~_
ELSE
ctbl	db	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3 ;00 000 ~@ - ~O
	db	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3 ;10 016 ~P - ~_
endIF
	db	2,4,1,1,1,4,1,4,1,1,1,1,1,1,1,1 ;20 032 ! % ' -> '| '/ '`
	db	1,1,1,1,1,1,1,1,1,1,4,4,1,1,1,1 ;30 048 : ;   -> '. ',
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;40 064
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4 ;50 080 _     -> '-
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;60 096
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,1 ;70 112 ~     -> '?
;		0 1 2 3 4 5 6 7 8 9 A B C D E F
IF 1
;these eight rows of the table correspond to operation with the 'H'
;parameter specified. If the 'H' parameter is NOT specified, these eight
;rows are overriden to match what's in the ELSE case below
htbl	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;80 128
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;90 144
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3 ;A0 160 ~< ~> guillemets
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;B0 176
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;C0 192
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ;D0 208
	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1 ;E0 224 ~{	 
	db	3,1,1,1,1,1,1,1,1,1,1,1,1,5,7,6 ;F0 240 ~=	 
ELSE
htbl	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 ;80 128
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 ;90 144
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,3 ;A0 160 ~< ~> guillemets
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 ;B0 176
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 ;C0 192
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5 ;D0 208
	db	5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,5 ;E0 224 ~{	 
	db	3,5,5,5,5,5,5,5,5,5,5,5,5,5,7,6 ;F0 240 ~=	 
endIF
;
include xyverbs.inc
;
csprot	db	"'0 checksum ",13,10
;
linestart dw	0	;DI value at last start of output line
crc32d	dw	0,0	;CRC32 accumulator
crc32sw db	0	;doing CRC32 switch
dobytes db	0	;force ~ddd enc, until counted down to zero
do1cr	db	0	;to keep a 3 byte CR, 1 byte LF sequence from
			;being seen as CRLF
;
;'maxline' limits output line length. We set it 3 lower than the
;requested maximum, because the need to avoid spliting tokens can cause
;up to three characters more (for ~ddd tokens) than our target length.
;But then we use "ja" test where we should use a "jnb" test, as a way of
;allowing a 'maxline' value of 255 to kill line breaking entirely, which
;means that we then need to subtract one more from the maxline reference
;value. So the net is that 'maxline' needs to be set 4 lower than the
;requested length.
;
maxline db	255	;max out line length minus 4, or 255
didwrite db     0       ;flag to set if a write has been done
;
;'dobrk' does a line break
dobrk	proc	near
	mov	ax,0A0Dh
	stosw
	xor	ax,ax
	mov	word ptr cs:linestart,di
	ret
dobrk	endp
;
;'chkbrk' checks if it is time to do a line break. A 'jb' test should be
;used on return. Buffer wrap is an issue, but buffer size is always a
;multiple of 800h. With a linewrap trigger of only 99 chars max,
;throwing away AH after the subtract is all we need do to accomodate the
;buffer wrap problem
chkbrk	proc	near
	mov	ax,di
	sub	ax,word ptr cs:linestart
	mov	ah,0
	cmp	byte ptr cs:maxline,al
	ret
chkbrk	endp
;
;the 'inout.inc' include branches to 'rdwr' to start
rdwr:	call	stdrw
	jcxz	donex	;need breathing room
	cmp	byte ptr cs:crc32sw,al	;doing CRC
	je	nocrc1	;jmp if not
	push	ds
	push	si
	push	cs
	pop	ds
	mov	si,offset csprot
	mov	cx,12/2
	rep	movsw   ;move in chksum token boilerplate
	mov	al,' '
	mov	cl,8
	rep	stosb   ;space for actual checksum
	movsw		;CRLF
	pop	si
	pop	ds
	call	stdrw	;bring counts & stuff up to date
nocrc1: cmp	word ptr cs:infile,ax
	je	mainloop	;no date if stdin
	mov	bx,word ptr cs:datedx
	test	bx,bx
	jz	mainloop	;jmp if date zero
	call	putdate 	;put the date token (20 bytes)
	call	stdrw	;bring counts & stuff up to date, clr AX
	inc	si	;SI must be 1+ do do rfshchk
;branch to doeol to emit a line break
doeol:	mov	bl,2
	call	rfshchk
	jc	rdwrx
	dec	si	;no input used for this output
	sub	cx,bx
	call	dobrk   ;emit the CRLF
	jmp	short skip1
;
donex:	cmp	byte ptr cs:crc32sw,al	;crc requested
	je	donex02
	call	putcrc	;overlays crc at start of output file
donex02:jmp	done
;
bytemode:mov	bl,4
	call	rfshchk
	jc	rdwrx
	dec	byte ptr cs:dobytes
dodec3: call	dec3
	jmp	short skip1
;
rdwrx:	call	stdrw
	jcxz	donex
mainloop:call	chkbrk	;check if time to emit CRLF
	lodsb
	jb	doeol	;branch if time to emit CRLF
	cmp	byte ptr cs:dobytes,ah
	jne	bytemode	;jmp if dobytes nonzero
	mov	bl,al
	mov	bl,cs:ctbl[bx]
	dec	bx
	jnz	special 	;jump if not simple char
put1:	stosb
skip1:	loop	mainloop
	jmp	short rdwrx
;
special:dec	bx
	jnz	not2
;blank
	mov	al,'_'
	jmp	short put1
;we have somthing that will involve at least 2 bytes in or out
not2:	xchg	bx,ax
	mov	bl,2
	call	rfshchk
	jc	rdwrx
	dec	ax
	jnz	not3
;we have something that encodes to 2 byte tilde encode
	cmp	cx,2
	jb	notCRLF 	;jmp if on last byte of file
	cmp	word ptr ds:[si-1],0A0Dh
	jne	notCRLF
	shr	byte ptr cs:do1cr,1	;was CR from 3 byte encode
	jc	notCRLF 		;jmp if so
	sub	cx,bx
	inc	si		;advance input past LF
	mov	al,"'"
	stosb
	mov	al,'^'
	jmp	short put1
;
notCRLF:call	tilde2x
	jmp	short put1
;
not3:	dec	ax
	jnz	not4
;we have something that encodes to 2 byte rsquote encode
	call	quote2x
	jmp	short put1
;
;remaining possible inputs
;  3 byte encode	need 3 bytes of input available
;  1 byte encode	need 1 byte of input available
;remaining possible emits:
;  "~ddd"		need 4 bytes of out space
;  "'aa" (function)	need 3 bytes of out space
;  ":" or ";"		need 1 byte of out space
;  "!cc:" or "!cc;"	need 4 bytes of out space
;  "!cc'aa"		need 6 bytes of out space
;
;in addition, we might need two bytes for a CRLF after the !cc
;
;note that for the cases which emit a ":" or ";", the rest of the output
;encoding could be as bad as "^ddd", for another 4 byte output
;requirement. But we need not account for that space now, because for
;these cases we are first collapsing a 3 byte encoding to a single byte,
;and we stick that byte in the input stream to be rescanned. The
;required space will then be allocated in processing the rescan.
;
not4:	mov	bl,6+2	;2 for possible CRLF
	call	rfshchk
	jc	rdwrx
	dec	ax
	jz	dodec3	;80h or above, ~ddd output case (4 out rqd)
;
;3 byte encoding of some form
;
	cmp	cx,3
	jnb	got3	;must have at least 3 on the input side
punt	label	near
IF HOOKS
	call	puntdebug
endIF
	mov	byte ptr cs:dobytes,3
	jmp	bytemode
;
got3:	call	dofx
	jnc	skip1
	jmp	short punt
;
;============================= SUBROUTINES =============================
;
;'putnum' converts the value in AX to a stream of CL printable decimal
;digits, which are pushed onto the stack. It then checks BL, and if BL
;is non-zero, emits BL to the ES:DI output stream. Finally, 'putnum'
;puts the CL digits from the AX conversion to the ES:DI output stream
;
;In:  AX: value to be converted
;     BL: prefix to be emitted, or zero
;     CL: number of digits to be outputted
;Out: AH, CX: zero
;     BX, DI, DX:unchanged
;     ES:DI stream: updated
;
putnum	proc	near
	push	dx
	push	si
	mov	si,10
	mov	ch,cl
rdxlp:	xor	dx,dx
	div	si	;low digit to DX
	push	dx	;push on stack
	dec	ch
	jnz	rdxlp	;loop as requested
	test	bl,bl
	jz	putlp
	mov	al,bl
	stosb
putlp:	pop	ax
	add	al,'0'
	stosb
	loop	putlp
	pop	si
	pop	dx
putnum	endp
;
;'extract' extracts CL low order bits from BX in AX, and then shifts
;BX right CL bits to the right
;
;In:  CL: number of bits to be extracted
;     BX: value with bits to be extracted
;Out: AX: low order 16-CL bits of BX
;     BX: remaining bits, right justified
;     CX: preserved
;     other regs preseved
;
extract proc	near
	mov	ax,-1
	shl	ax,cl
	not	ax
	and	ax,bx
	shr	bx,cl
	ret
extract endp
;
;'putdate' puts a line at ES:DI containing the file date
putdate proc	near
;Only called at start of output file
;In:  BX=date from INT 21h fcn 57h
;     cs:datecx=time from INT 21h fcn 57h
;Out: ES:DI stream updated
;     AH=0,BH=0
;     AL,BL destroyed
;     other regs unchanges
	push	cx
	mov	al,"'"
	stosb
	mov	cl,5	;day, 1-31
	call	extract
	push	ax	;push day
	dec	cx	;month, 1-12
	call	extract
	add	bx,1980 ;year
	pop	cx	;day
	push	bx	;year, 1980-2099
	push	cx	;day
	push	ax	;month
;month/day/year on stack, put to output stream
	mov	cl,3	;three items on stack
	xor	bx,bx	;no prefix for month
dateloop:pop	ax	;get stack item
	push	cx
	cmp	cl,1
	mov	cl,4	;4 decimal digits for year
	je	dtyr	;jmp if year
	mov	cl,2	;2 decimal digits wanted otherwise
dtyr:	call	putnum	;put possible prefix and CL digits
	pop	cx
	mov	bl,'-'	;'-' prefix for day, year
	loop	dateloop	;loop to process day, year
	mov	al,' '
	stosb
	mov	bx,word ptr cs:datecx	;time
	mov	cl,5	;seconds / 2, 0-29
	call	extract
	shl	ax,1	;convert to seconds, 0-58
	push	ax	;push seconds
	inc	cx	;minutes, 0-59
	call	extract
	push	ax	;push minutes
	push	bx	;push hours, 0-23
;hour/min/sec on stack, put to output stream
	mov	cl,3	;three items on stack
	xor	bx,bx	;no prefix for hour
timeloop:pop	ax	;get stack item
	push	cx
	mov	cl,2	;2 decimal digits wanted
	call	putnum	;put possible prefix and 2 digits
	pop	cx
	mov	bl,':'	;':' prefix for min, sec
	loop	timeloop
	pop	cx
	ret
putdate endp
;
;'tilde2x' handles 2 byte tilde prefixed encodings
tilde2x proc	near
	mov	al,'~'
	stosb
	sub	cx,bx
	mov	al,ds:[si-1]
	cmp	al,0AEh ;map to '<'
	je	isAE
	cmp	al,0AFh ;map to '>'
	je	isAF
	cmp	al,0EEh ;map to '{'
	je	isEE
	cmp	al,0F0h ;map to '='
	je	isF0
iscontrol:add	al,'@'
	ret
isF0:	mov	al,'='
	ret
isAE:	mov	al,'<'
	ret
isAF:	mov	al,'>'
	ret
isEE:	mov	al,'{'
	ret
tilde2x endp
;'quote2x' handles 2 byte rsquote prefixed encodings
quote2x proc	near
	mov	al,"'"
	stosb
	sub	cx,bx
	mov	al,ds:[si-1]
	cmp	al,'!'	;map to |'
	je	is21
	cmp	al,'%'	;map to /
	je	is25
	cmp	al,"'"	;map to `
	je	is27
	cmp	al,':'	;map to .
	je	is3A
	cmp	al,';'	;map to ,
	je	is3B
	cmp	al,'_'	;map to -
	je	is5F
;has to be '~' at this point
;	cmp	al,'~'	;map to ?
;	je	is7E
is7E:	mov	al,'?'
	ret
;
is21:	mov	al,'|'
	ret
is25:	mov	al,'/'
	ret
is27:	mov	al,'`'
	ret
is3A:	mov	al,'.'
	ret
is3B:	mov	al,','
	ret
is5F:	mov	al,'-'
	ret
quote2x endp
;
;'dec1' converts AX <= 999 to 3 ASCII output digits at ES:DI.
;CX=3 on initial call, recursively calls itself
;
dec1	proc	near
	mov	bl,10
	div	bl	;low digit to AH, rest to AL
	xor	bx,bx
	xchg	bl,ah	;clear AH, BX=low dight
	push	bx	;push low digit
	dec	cx
	jcxz	de02
	call	dec1	;recurse
de02:	pop	ax	;pop high digit first
	add	al,'0'	;convert to ASCII
	stosb
	ret
dec1	endp
;
;'dec3x' converts AX <= 999 to 3 ASCII output digits at ES:DI
;sets up for and invokes 'dec1'
;also emits leading "~", decrements CX as required
;must return with carry clear
;
dec3	proc	near	;call here to process a char at DS:SI-1
	mov	al,ds:[si-1]
dec3x:	push	ax
	mov	al,'~'
	stosb
	pop	ax
	sub	cx,bx
	push	bx
	push	cx
	mov	cx,3
	call	dec1
	pop	cx
	pop	bx
	ret
dec3	endp
;'hexadj' converts hex value in AL to printable ASCII
hexadj	proc	near
	cmp	al,10
	jb	hexa02
	add	al,7
hexa02: add	al,'0'
	ret
hexadj	endp
;
;'emitexcm' formats and emits an exclaim packet
emitexcm proc	near
	call	hexadj	;AL to ASCII form
	xchg	ah,al	;AL=byte 2 adj, AH=byte 3 adj
	call	hexadj	;AL to ASCII form
	push	ax
	mov	al,'!'
	stosb		;emit non-std encoding flag
	pop	ax
	stosw		;non-std reconstruct data
	call	chkbrk	;check if we a line break
	jnb	emit02	;jump if not
	call	dobrk	;emit the line break
emit02: ret
emitexcm endp
;
;'hex' does the same conversion to hex that XyWrite III+ does with bytes
;2 and 3 of 3 byte encoded characters. Note that XyWrite III accepts and
;does some conversion with any byte value.
;in:  AL=byte 2 or 3 of 3 byte encoded data
;     CH=even value
;out: AL[3:0]=hex nibble out, for conversion as per XY III
;     carry set if not ASCII '0'-'9' or 'A'-'F' input
;     AL[7:4]=high order residue rqd to construct original byte
;     CH[0]=1 if input was ":"-"@" (3Ah to 40h). In reconstruct of
;	original, this serves as a flag to differentiate ":"-"@" input
;	from '0'-'9' input values.
;
hex	proc	near
	add	al,246-'0';C6h	;'0' to '9' to 246 to 255
	sub	al,256-10 ;F6h	;'0' to '9' to 0-9 w/no carry
	jnb	hex02		;at -'0', jmp if '0' to '9' in
	cmp	al,17	  ;11h
	jb	hex04		;jmp if 3Ah to 40h
	add	al,250-17 ;E9h	;'A'-'F' to 250 to 255
	sub	al,256-16 ;F0h	;'A'-'F' to 10 to 15 w/no carry
				;at -'0'-7
hex02:	pushf
	add	al,'0'		;at 0 or -7
	popf
	ret
;3Ah to 40h case, now mapped to 0Ah to 10h (-;'0')
hex04:	inc	ch		;flag required
	sub	al,256+7-'0'	;at -7, carry set
	ret
hex	endp
;
;'dofx' handles 0FFh and 0FEh prefixed data
;
dofx	proc	near
	dec	ax
	mov	ax,ds:[si]	;AL=byte 2, AH=byte 3
	jz	doff
;handling 0FEh triples
	cmp	ax,1000-256	;word after 0FEh is char-256
	jnb	dofx3er 	;jump if will be >999
	inc	ah		;add in the 256
	inc	si
	inc	si
	call	dec3x
	ret
;handling 0FFh triples
doff	label	near
	cmp	al,80h
	jnb	is80	;jmp if function or XY IV 2nd encoding
;handling 0FFh,h,h case, where h=hex digit in ASCII
	push	cx
	mov	cx,4	;CH=0, CL=4
	call	hex	;test/convert high order digit
	pushf		;save error indicator
	shl	ch,1	;save "is ':'-'@'" flag for high digit
	xchg	ah,al	;AH=byte 2, AL=byte 3
	call	hex	;test/convert low order digit
	jc	hexbad	;jmp if not std ASCII hex digit
	popf
	jnc	ok2hex	;jmp if both are std ASCII hex digit
	jmp	short hexbad1
;
hexbad: popf		;carry on byte 3, ignore carry on byte 2
;non-std byte 2 or 3 digit -- need a "!" type correction for decode
hexbad1:push	ax	;save for normal encoded 1 byte
	dec	cx	;CL=3
	shr	ch,1	;byte 3 "flag" bit to carry
	rcr	al,1	;high nibble to AL[3:0] ...
	shr	al,cl	;... while flag goes to AL[4]
	shr	ch,1	;byte 2 "flag" bit to carry
	rcr	ah,1	;high nibble to AH[3:0] ...
	shr	ah,cl	;... while flag goes to AH[4]
	inc	cx	;CL back to 4
	call	emitexcm	;emit the exclaim packet
	pop	ax	;data for normal encoded 1 byte
ok2hex: shl	al,cl
	shl	ax,cl	;indicated 1 byte char now in AH
	pop	cx
	mov	al,":"	;indicate 3 byte encoded char
dofx3:	stosb		;put the prefix
	inc	si	;set to rescan byte 3 of encoding
	mov	ds:[si],ah ;replace byte 3 with 1 byte decode
;next scan will take care of encoding the single byte
	cmp	al,0Dh
	jne	notCR
	inc	byte ptr cs:do1cr
notCR:	cmp	ah,0FDh
	jb	dofx3ne
	inc	byte ptr cs:dobytes ;force ~ddd encode if >=0FDh
dofx3ne:sub	cx,bx
	clc		;no error exit branch
dofxret:mov	ah,0
	ret
;
dofx3er:stc		;error exit branch
	jmp	short dofxret
;
is80:	xchg	ah,al
	cmp	ax,0C080h
	jnb	isc0
;3 byte encoded functional primitive
	sub	ah,80h
	cmp	ax,verbcnt*2
	jnb	dofx3er
	test	al,1
	jnz	is80nor ;jump if normal encoding
;abnormal (but accepted) fcn encoding - byte 3 not odd
	inc	ax	;convert to accepted for lookup
	push	ax
	xor	ax,ax
	call	emitexcm
	pop	ax
is80nor:inc	si
	inc	si
	xchg	bx,ax
	mov	bx,word ptr cs:verbs-1[bx]
	xchg	bx,ax
	push	ax
	mov	al,"'"
	stosb
	pop	ax
	stosw
	jmp	short dofx3ne
;
;0FFh,0C0h,080h based encode
;(XyWrite IV alternate 3 byte data encoding for search args)
isc0:	sub	ax,0C080h
	test	ah,ah
	jz	isc0nor
	push	ax
	push	cx
	mov	cl,4
	shr	ax,cl
	shr	al,cl
	call	emitexcm	;emit the exclaim packet
	pop	cx
	pop	ax
isc0nor:mov	ah,al
	mov	al,";"	;indicate 3 byte type 2 data encoding
	jmp	short dofx3
dofx	endp
;
crc32in proc	near
	test	ax,ax		;any bytes read
	jz	nocrc2		;jmp if not
	cmp	byte ptr cs:crc32sw,0	;are we doing CRC?
	je	nocrc2		;jmp if not
IF HOOKS
	call	crcdebug
endIF
	push	di
	push	si
	push	dx
	push	ax
	push	bx
	push	cx
	mov	di,ax		;count
	mov	si,dx		;start address
	mov	ax,word ptr cs:crc32d
	mov	dx,word ptr cs:crc32d+2
; ;	call	crc32	;proc included inline
; ;crc32	proc	near
;In:	DX:AX		CRC so far
;	DS:SI		buffer ptr
;	DI		count
;	crctab,crctabh	filled in
;Out:	DX:AX		updated
;	BX,CX,SI,DI	destroyed
;	direction	fwd
; ;	cld
	not	ax
	not	dx
	shr	di,1
	inc	di
	jnc	cr06
	mov	cx,dx
	jmp	short cr04
;
cr02:	mov	bl,al
	lodsb
	xor	bl,al
	mov	al,ah
	shl	bx,1
	mov	ah,dl
	mov	cx,word ptr cs:crctabh[bx]
	xor	ax,word ptr cs:crctab[bx]
	xor	cl,dh
cr04:	mov	bh,0
	mov	bl,al
	lodsb
	xor	bl,al
	mov	al,ah
	shl	bx,1
	mov	ah,cl
	mov	dx,word ptr cs:crctabh[bx]
	xor	ax,word ptr cs:crctab[bx]
	xor	dl,ch
cr06:	dec	di
	mov	bh,0
	jnz	cr02
cr08:	not	ax
	not	dx
; ;	ret
; ;crc32	endp
	mov	word ptr cs:crc32d,ax
	mov	word ptr cs:crc32d+2,dx
	pop	cx
	pop	bx
	pop	ax
	pop	dx
	pop	si
	pop	di
nocrc2: ret
crc32in endp
;
;'put16' puts AX to ES:DI stream as printable hex
put16	proc	near
	push	ax
	mov	al,ah
	call	put8
	pop	ax
put8:	push	ax
	mov	cl,4
	shr	al,cl
	call	put4
	pop	ax
put4:	and	al,0Fh
	add	al,'0'
	cmp	al,'9'+1
	jb	put4x
	add	al,7
put4x:	stosb
	ret
put16	endp
;
;'putcrc' puts the computed CRC token at start of file
putcrc	proc	near
	mov	bx,word ptr cs:outfile
	cmp	bx,2
	jb	pc08	;no CRC if stdout
	push	ds
	push	es
	pop	ds	;for IO ops, if any
	push	di
	mov	dx,12	;offset to where CRC goes
	cmp	byte ptr cs:didwrite,0 ;have we done a write yet
	pushf
	jne	pc02	;yep -- just build CRC at where DI now points
	mov	di,dx	;nope - fill in data still in buffer
pc02:	mov	ax,word ptr cs:crc32d+2
	call	put16
	mov	ax,word ptr cs:crc32d
	call	put16
	popf		;have we done a write yet
	je	pc06	;nope -- updated in buffer, we're done
	mov	ax,4200h	;seek rel to beg of file
	xor	cx,cx		;high order offset 0
; ;	mov	dx,12		;offset (already set)
	int	21h
	jc	pc04		;skip write if error
	mov	ah,40h		;write
	mov	cl,8		;8 bytes
	pop	dx		;point at where we dumped the CRC
	push	dx
	int	21h
pc04:	mov	ax,4202h	;seek rel to end of file
	xor	cx,cx		;offset 0
	xor	dx,dx		;ditto
	int	21h		;back to end of file
pc06:	pop	di
	pop	ds
pc08:	ret
putcrc	endp
;
	assume	ds:_TEXT
warnings proc	near
	ret
warnings endp
;
usemsg	db	'XYENC v0.95 (c) Wally Bass 2009. Released to the'
	db	' Public Domain.',13,10,10
	db	'Usage: XYENC file_in file_out [nn] [L] [H] [B] [C]'
	db	13,10,10
	db	'Option switches:',13,10
	db	'  nn : max output line length to be as indicated'
	db	' (20 to 99)',13,10
	db	'  L  : allow most Low chars (01h-1Fh) to pass'
	db	' without encoding',13,10
	db	'  H  : allow most High chars (80h-0FCh) to pass'
	db	' without encoding',13,10
	db	'  B  : do Both L and H',13,10
	db	'  C  : output to include CRC32 checksum token for'
	db	' input file',13,10,10
	db	"Specify filename of '.' for std input or std output"
	db	13,10,10
	db	'Encodes XyWrite or NotaBene XPL program or text'
	db	' files to files',13,10
	db	'containing only character codes 20h through 7Fh'
	db	' and CRLFs',13,10,10
	db	'The XYDEC program recreates the original',13,10,10,'$'
;
IF HOOKS
;
;a call to 'debug1" is the very first thing the the XYENC module does.
;This makes it easy to find the following with a debugger
	db	'start'
debug1	proc	near
	hookcode
debug1	endp
;'debug2' is called right before initial entry into our main loop
	db	'mainlp'
debug2	proc	near
	hookcode
debug2	endp
;'optdebug' is called when we start to parse the third parm
	db	'parm3'
optdebug proc	near
	hookcode
optdebug endp
;'crcdebug' is called when we are about do process data for CRC32
	db	'crc32'
crcdebug proc	near
	hookcode
crcdebug endp
;'puntdebug' is called if XYENC must resort to three ~ddd's for a 3 byte
;encoded entity.
	db	'punt'
puntdebug proc	near
	hookcode
puntdebug endp
endIF
;
; ;	dobuffer		;we do our own version
t = (offset s0+8000h-$) mod 16
IF t
	db	t dup(0)	;to paragraph boundary for buffer
endIF
;
crctab	equ	this word	;filled in by crcbld subr
;
crctabh equ	this word+512	;filled in by crcbld subr
;
buffer	equ	this word+1024
t = (offset s0+8100h-$) mod 512
IF t
	db	t dup(0)	;pad to mult of 512 for faster loading
endIF
;
_TEXT	ends
	end	start
